/*************************************************************************
 *                                                                       *
 * Last.fm Player, Copyright (C) 2005 Chris Muehlhaeuser, Last.fm Ltd.   *
 * All rights reserved.  Email: chris@last.fm                            *
 *                                                                       *
 * This library is free software; you can redistribute it and/or         *
 * modify it under the terms of:                                         *
 *                                                                       *
 *      The BSD-style license that is included with this library in      *
 *      the file LICENSE.                                                *
 *                                                                       *
 * This library is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file     *
 * LICENSE for more details.                                             *
 *                                                                       *
 *************************************************************************/

#include "progressframe.h"
#include <QPainter>


ProgressFrame::ProgressFrame( QWidget *parent )
    : QFrame( parent )
{
    m_maxValue = 1;
    m_value = 0;

    setMinimumHeight( 16 );
    setFrameStyle( QFrame::Panel | QFrame::Sunken );
    setLineWidth( 1 );
}


void ProgressFrame::paintEvent ( QPaintEvent * event )
{
    QPainter painter( this );

    drawFrame( &painter );

    painter.setPen( QColor( 145, 153, 142, 255 ) );
    painter.setBrush( QColor( 145, 153, 142, 255 ) );

    int w = ( (float)m_value / (float)m_maxValue ) * ( width() - 8 );
    if ( w > width() - 8 )
        w = width() - 8;

    painter.drawRect( 3, 3, w, 8 );
}


void
ProgressFrame::setMaximum( int value )
{
    m_maxValue = value;
}


void
ProgressFrame::setValue( int value )
{
    m_value = value;
    update();
}


int
ProgressFrame::value()
{
    return m_value;
}

